using System;
using System.Drawing ;
using System.Drawing.Design ;
using System.ComponentModel ;
using System.Windows.Forms.Design ;

namespace ExtendedDataGrid.Utilities
{
	/// <summary>
	/// 
	/// </summary>
	internal class DataMemberFieldEditor : System.Drawing.Design.UITypeEditor
	{
		private DesignBindingPicker designBindingPicker;
		private const string PRFX="Combo";
		private const string SFX="DataSource"; 


		public DataMemberFieldEditor():base()
		{
		}


		public new UITypeEditorEditStyle GetEditStyle()
		{
				return this.GetEditStyle(null); 
		}


		public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			IWindowsFormsEditorService service1;
			PropertyDescriptor descriptor1;
			object obj1;
			if (provider != null)
			{
				service1 = ((IWindowsFormsEditorService) provider.GetService(typeof(IWindowsFormsEditorService)));
				if ((service1 != null) && (context.Instance != null))
				{
					if (this.designBindingPicker == null)
					{
						this.designBindingPicker = new DesignBindingPicker(context, false, false);
 
					}
					descriptor1 = TypeDescriptor.GetProperties(context.Instance)[PRFX+SFX];
					if (descriptor1 != null)
					{
						obj1 = descriptor1.GetValue(context.Instance);
						if (obj1 != null)
						{
							this.designBindingPicker.Start(context, service1, obj1, new DesignBinding(obj1, ((string) value)));
							service1.DropDownControl(this.designBindingPicker);
							if (this.designBindingPicker.SelectedItem != null)
							{
								value = this.designBindingPicker.SelectedItem.DataMember;
 
							}
							this.designBindingPicker.End();
							return value;
 
						}
						this.designBindingPicker.Start(context, service1, obj1, new DesignBinding(null, ((string) value)));
						service1.DropDownControl(this.designBindingPicker);
						this.designBindingPicker.End();
 
					}
 
				}
 
			}
			return value;
 
		}

		public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
		{
				return UITypeEditorEditStyle.DropDown; 
		}


	}


}
