using System;
using System.ComponentModel ;
using System.Drawing ;
using System.Windows.Forms ;
using System.Windows.Forms.Design ;
using System.Globalization  ;


namespace ExtendedDataGrid.Utilities
{
	/// <summary>
	/// Utility class
	/// </summary>
	[Editor("System.Windows.Forms.Design.DesignBindingEditor","System.Drawing.Design.UITypeEditor")]
	internal class DesignBinding
	{
		private string dataMember;
		 
		private object dataSource;
		public static DesignBinding Null;

		 static DesignBinding()
		{
				DesignBinding.Null = new DesignBinding(null, null);
 
		}


		public DesignBinding(object dataSource, string dataMember):base()
		{
			this.dataSource = dataSource;
			this.dataMember = dataMember;
 
		}


		public bool Equals(object dataSource, string dataMember)
		{
				if (dataSource == this.dataSource)
		  {
			  return (string.Compare(dataMember, this.dataMember, true, CultureInfo.InvariantCulture) == 0); 
		  }
			return false; 
		}


		public string DataField 
		{
			get{ 
				int num1;
				num1 = this.dataMember.LastIndexOf(".");
				if (num1 == -1)
				{
					return this.dataMember; 
				}
				return this.dataMember.Substring((num1 + 1)); 
				} 
		}


		public string DataMember 
		{
			get{ return this.dataMember; 
								   } 
		}


		public object DataSource 
		{
			get{ return this.dataSource; 
								   } 
		}


		public bool IsNull 
		{
			get{ return (this.dataSource == null); 
				} 
		}
 
	}


}
